//+------------------------------------------------------------------+
//|                                             Hare-Ram-Krishan.mq4 |
//|                                               Gopal Krishan Doda |
//|                                        http://www.InvestmentKit.com |
//+------------------------------------------------------------------+



//  combination of Parabolic SAR; later modified by TRO; 
// to do - add EMA of 10 & 40 days to remove false sugnals of SAR.

#property copyright "Gopal Krishan Doda"
#property link      "http://www.InvestmentKit.com"


extern double TakeProfit = 80;
extern double StopLoss = 80;
extern double    Lot_Size=0.1;
extern double    Step=0.001;
extern int Diff=20; 
extern int ilimit =144; 

int magic_number=29021976;

double SarBuffer[];

int    save_lastreverse;
bool   save_dirlong;
double save_start;
double save_last_high;
double save_last_low;
double save_ep;
double save_sar;
double save_delta;

string symbol, tChartPeriod,  tShortName ;  
int    digits, period  ; 

bool Trigger ;

int OldBars = -1 ;

   static bool first=false;
   bool   dirlong;
   double start,last_high,last_low;
   double ep,sar,price_low,price_high,price;



   int    ticket,i;


int start()
  {

int counted_bars=IndicatorCounted();
         int limit=ilimit;


//----

//   if( Bars != OldBars ) { Trigger = True ; }

//      SetIndexDrawBegin(0,Bars-limit); 
//      SetIndexDrawBegin(1,Bars-limit); 
//----
   if(Bars<3) return(0);
   dirlong=true;
   start=Step;
//--------------------------------------------+
   i=Bars-2;
   while(i>=0)
     {
      price_low=Low[i];
      price_high=High[i];
      price=SarBuffer[i+1];
      sar=price+start*(ep-price);
//----
      if(dirlong)
        {
         start+=Step;
         if(sar>price_low)
           {
//            SaveLastReverse(i,true,start,price_low,last_high,ep,sar);
//    void SaveLastReverse(int last,int dir,double start,double low,double high,double ep,double sar)            
    
               save_lastreverse=i;
   save_dirlong=true;
   save_start=start;
   save_last_low=price_low;
   save_last_high=last_high;
   save_ep=ep;
   save_sar=sar;
            
            
            start=Step; 
            dirlong=false; 
            ep=price_low;
            last_low=price_low;
            SarBuffer[i]=last_high-Diff*Point;
            if (SarBuffer[i]<High[i]&&SarBuffer[i]>=Low[i]) 
                SarBuffer[i]=High[i]+Point;
            if (SarBuffer[i]<Low[i]) SarBuffer[i]=Low[i]-Point;
            i--;
            continue;
           }
         if(ep<price_high) { last_high=price_high; ep=price_high; }
        }
//----
      else
        {
         start+=Step;
         if(sar<price_high)
           {
//            SaveLastReverse(i,false,start,last_low,price_high,ep,sar);
            
              save_lastreverse=i;
   save_dirlong=false;
   save_start=start;
   save_last_low=last_low;
   save_last_high=price_high;
   save_ep=ep;
   save_sar=sar;
 
            
            start=Step; 
            dirlong=true; 
            ep=price_high;
            last_high=price_high;
            SarBuffer[i]=last_low+Diff*Point;
            if (SarBuffer[i]>Low[i]&&SarBuffer[i]<=High[i]) 
                SarBuffer[i]=Low[i]-Point;
            if (SarBuffer[i]>High[i]) SarBuffer[i]=High[i]+Point;
            i--;
            continue;
           }
         if(ep>price_low) { last_low=price_low; ep=price_low; }
        }
      SarBuffer[i]=sar;
      i--;
     }
     
    
//----

      
     //Print (SarBuffer[0]);
      

        if( Close[0] > SarBuffer[0] && Close[1] < SarBuffer[1] ) 
        {

   ticket=OrderSend(Symbol(),OP_BUY, Lot_Size, Ask, 3, Ask-StopLoss*Point, Ask+TakeProfit*Point, "SAR Long Orders", magic_number, 0, Green);


               if(ticket>0)
           {
               if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
               else Print("Error opening BUY order : ",GetLastError()); 
            
         

// buy here
//         Trigger = False ; Alert(Symbol(),"  ", Period(), " Price above PSAR "+ DoubleToStr(SarBuffer[0] ,5)); 
         }

        if( Close[0] < SarBuffer[0] && Close[1] > SarBuffer[1] ) 
        { 

//sell here
//        Trigger = False ; Alert(Symbol(),"  ", Period(), " Price below PSAR "+ DoubleToStr(SarBuffer[0] ,5)); 

        }     


   OldBars = Bars ;   



return(0);
  }
// the end.